<!DOCTYPE html>
<html>
<head>
    <title>Doc</title>
   
    <style>
        * {
            margin: 0;
            padding: 0;
        }

        body {
            text-align: center;
        }

        h1 {
            margin-bottom: 20px;
        }

        h2 {
            margin-bottom: 20px;
        }

        .add_user {
            margin-bottom: 50px;
        }

        .users_list .user_card {
            margin-bottom: 20px;
        }

        .delete_user {
            margin-bottom: 50px;
        }
    </style>
</head>
<body>
<h2>Список користувачів</h2>
<div class="users_list"></div>
<div class="add_user">
    <form action="" onsubmit="return false" id="add_form">
        <input type="number" id="user_code" placeholder="Код">
        <input type="text" id="user_full_name" placeholder="ПІБ">
        <input type="text" id="user_car_brand" placeholder=" марка">
        <input type="text" id="user_car_number" placeholder="номер машини">
        <input type="text" id="user_color" placeholder="колір">
        <button id="add_btn" class="btn btn-primary">Добавити користувача</button>
    </form>
</div>
<div class="delete_user">
    <form action="" onsubmit="return false">
        <input type="text" id="delete" placeholder="ПІБ">
        <button id="delete_btn" class="btn btn-danger">Видалити користувача</button>
    </form>
</div>
<div class="change_user">
    <form action="" onsubmit="return false">
        <input type="text" id="change_full_name" placeholder="ПІБ">
        <input type="text" id="change_car_brand" placeholder=" марка">
        <input type="text" id="change_car_number" placeholder="номер машини">
        <input type="text" id="change_color" placeholder="колір">
        <button id="change_btn" class="btn btn-primary">Змінити користувача</button>
    </form>
</div>

>
<script>
    class Trafficpolice {
        constructor(code, fullname, carbrand, carnumber, color) {
            this.code = code;
            this.fullname = fullname;
            this.carbrand = carbrand;
            this.carnumber = carnumber;
            this.color = color;
        }
    }

    class Trafficpolices {
        constructor() {
            this.trafficPolice = [];
        }

        toString() {
            let res = "";
            for (let user of this.trafficPolice) {
                res += user.fullname + " ";
            }
            return res;
        }

        checkUsers(user_full_name) {
            let index = this.trafficPolice.findIndex(user => user.fullname === user_full_name);
            if (index === -1) {
                return true;
            } else {
                return false;
            }
        }

        add(object) {
            if (object instanceof Trafficpolice) {
                this.trafficPolice.push(object);
            }
        }

       

        delete(fullname) {
            let index = this.trafficPolice.findIndex(user => user.fullname === fullname);
            if (index > -1) {
                this.trafficPolice.splice(index, 1);
            }
        }

        changeUser(fullname) {
            let new_car_brand = document.querySelector("#change_car_brand").value;
            let new_car_number = document.querySelector("#change_car_number").value;
            let new_full_name = document.querySelector("#change_full_name").value;
            let new_color = document.querySelector("#change_color").value;
            let index = this.trafficPolice.findIndex(user => user.fullname === fullname);
            if (index > -1) {
                if (new_car_number !== "") {
                    this.trafficPolice[index].carnumber = new_car_number;
                }
                if (new_car_brand !== "") {
                    this.trafficPolice[index].carbrand = new_car_brand;
                }
                if (new_full_name !== "") {
                    this.trafficPolice[index].fullname = new_full_name;
                }
                if (new_color !== "") {
                    this.trafficPolice[index].color = new_color;
                }
            } else {
                alert("Такого користувача не існує");
            }
        }
    }

    let New = new Trafficpolices();

    document.querySelector("#add_btn").addEventListener('click', () => {
        let code = document.querySelector("#user_code").value;
        let fullname = document.querySelector("#user_full_name").value;
        let carbrand = document.querySelector("#user_car_brand").value;
        let carnumber = document.querySelector("#user_car_number").value;
        let color = document.querySelector("#user_color").value;
        if (New.checkUsers(fullname)) {
            let new_user = new Trafficpolice(code, fullname, carbrand, carnumber, color);
            New.add(new_user);
            showUsers(New);
            alert("Користувача успішно додано");
        } else {
            alert("Такий користувач вже існує");
        }
    });

    const showUsers = function (list) {
        let card_holder = document.querySelector(".users_list");
        card_holder.innerHTML = "";
        for (let user of list.trafficPolice) {
            card_holder.innerHTML += `<div class='user_card'><h3 class='user_card_full_name'>${user.fullname}</h3><h3 class='user_card_full_name'>${user.carbrand}</h3></div>`;
        }
    };

    document.querySelector("#delete_btn").addEventListener('click', () => {
        let del_full_name = document.querySelector("#delete").value;
        New.delete(del_full_name);
        console.log(New.trafficPolice);
        showUsers(New);
    });

    document.querySelector("#change_btn").addEventListener('click', () => {
        let change_full_name = document.querySelector("#change_full_name").value;
        New.changeUser(change_full_name);
        console.log(New.trafficPolice);
        showUsers(New);
    });
</script>
</body>
</html>
